/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.records.TCoreMissingmasterRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreMissingmaster extends TableImpl<TCoreMissingmasterRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_missingmaster</code>
     */
    public static final TCoreMissingmaster T_CORE_MISSINGMASTER = new TCoreMissingmaster();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreMissingmasterRecord> getRecordType() {
        return TCoreMissingmasterRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_missingmaster.lastchange</code>.
     */
    public final TableField<TCoreMissingmasterRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_missingmaster.pk</code>.
     */
    public final TableField<TCoreMissingmasterRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_missingmaster.fk_lang</code>.
     */
    public final TableField<TCoreMissingmasterRecord, String> FK_LANG = createField(DSL.name("fk_lang"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_missingmaster.reproducible</code>. Is
     * this missing reprocudible (is it a jump missing or such)?
     */
    public final TableField<TCoreMissingmasterRecord, Boolean> REPRODUCIBLE = createField(DSL.name("reproducible"), SQLDataType.BOOLEAN.nullable(false), this, "Is this missing reprocudible (is it a jump missing or such)?");

    private TCoreMissingmaster(Name alias, Table<TCoreMissingmasterRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreMissingmaster(Name alias, Table<TCoreMissingmasterRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_missingmaster</code> table
     * reference
     */
    public TCoreMissingmaster(String alias) {
        this(DSL.name(alias), T_CORE_MISSINGMASTER);
    }

    /**
     * Create an aliased <code>common_dd.t_core_missingmaster</code> table
     * reference
     */
    public TCoreMissingmaster(Name alias) {
        this(alias, T_CORE_MISSINGMASTER);
    }

    /**
     * Create a <code>common_dd.t_core_missingmaster</code> table reference
     */
    public TCoreMissingmaster() {
        this(DSL.name("t_core_missingmaster"), null);
    }

    public <O extends Record> TCoreMissingmaster(Table<O> path, ForeignKey<O, TCoreMissingmasterRecord> childPath, InverseForeignKey<O, TCoreMissingmasterRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_MISSINGMASTER);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreMissingmasterPath extends TCoreMissingmaster implements Path<TCoreMissingmasterRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreMissingmasterPath(Table<O> path, ForeignKey<O, TCoreMissingmasterRecord> childPath, InverseForeignKey<O, TCoreMissingmasterRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreMissingmasterPath(Name alias, Table<TCoreMissingmasterRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreMissingmasterPath as(String alias) {
            return new TCoreMissingmasterPath(DSL.name(alias), this);
        }

        @Override
        public TCoreMissingmasterPath as(Name alias) {
            return new TCoreMissingmasterPath(alias, this);
        }

        @Override
        public TCoreMissingmasterPath as(Table<?> alias) {
            return new TCoreMissingmasterPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreMissingmasterRecord, Integer> getIdentity() {
        return (Identity<TCoreMissingmasterRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreMissingmasterRecord> getPrimaryKey() {
        return Keys.PK_CORE_MISSINGMASTER;
    }

    @Override
    public List<ForeignKey<TCoreMissingmasterRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_MISSINGMASTER__FK_MISSINGMASTER_LANG);
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_CORE_MISSINGMASTER__FK_MISSINGMASTER_LANG, null);

        return _tCoreTranslationKey;
    }

    @Override
    public TCoreMissingmaster as(String alias) {
        return new TCoreMissingmaster(DSL.name(alias), this);
    }

    @Override
    public TCoreMissingmaster as(Name alias) {
        return new TCoreMissingmaster(alias, this);
    }

    @Override
    public TCoreMissingmaster as(Table<?> alias) {
        return new TCoreMissingmaster(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMissingmaster rename(String name) {
        return new TCoreMissingmaster(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMissingmaster rename(Name name) {
        return new TCoreMissingmaster(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMissingmaster rename(Table<?> name) {
        return new TCoreMissingmaster(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingmaster where(Condition condition) {
        return new TCoreMissingmaster(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingmaster where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingmaster where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingmaster where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissingmaster where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissingmaster where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissingmaster where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissingmaster where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingmaster whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingmaster whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
